<%-- $Id:tree.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.Registry"
	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.Action"
	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.util.extensions.manager.ExtensionKey"
	import="net.sf.basedb.util.extensions.manager.ExtensionPointKey"
	import="net.sf.basedb.util.extensions.xml.PluginInfo"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.core.plugin.About"
	import="java.util.List"
	import="java.util.Iterator"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
String getJoustExtensionPoint(String parentNode, ExtensionsControl ec, ExtensionPoint ep, ExtensionsFile ef)
{
	String id = ep.getId();
	String name = ep.getName();
	if (name == null) name = id;
	String icon = ec.isEnabled(ep) ? "ExtensionPoint" : "ExtensionPointDisabled";
	if ((ef != null && ef.hasError()) || ec.getLastExtensionPointError(id) != null) 
	{
		icon = "ExtensionPointError";
	}
	String joust = "ep = JoustMenu.addChildItem(" + parentNode +", '" + icon + "', " + 
			"'" + HTML.javaScriptEncode(name) + "', 'extensionPointOnClick(\"" + id + "\")', " + 
			"'', '" + id + "')";
	return joust;
}
String getJoustExtension(String parentNode, ExtensionsControl ec, Extension ext, ExtensionsFile ef, boolean inGroup, boolean showFile)
{
	String id = ext.getId();
	About about = ext.getAbout();
	String name = about == null || about.getName() == null ? id : about.getName();
	if (inGroup) name = ext.getId().substring(ext.getId().indexOf(":"));
	if (showFile)
	{
		name += " <span class=\"itemref\">[" + ef.getName() + "]</span>";
	}
	else
	{
		name += " <span class=\"itemref\">[" + ec.getExtensionPoint(ext.getExtends()).getName() + "]</span>";
	}
	String icon = ec.isEnabled(ext) ? "Extension" : "ExtensionDisabled";
	if ((ef != null && ef.hasError()) || ec.getLastExtensionError(id) != null)
	{
		icon = "ExtensionError";
	}
	String joust = "ext = JoustMenu.addChildItem(" + parentNode + ", '" + icon + "', " + 
			"'" + HTML.javaScriptEncode(name) + "', 'extensionOnClick(\"" + id + "\")', " + 
			"'', '" + id + "')";
	return joust;
}
String getExtensionGroup(String parentNode, ExtensionsControl ec, Extension ext, String groupId)
{
	String id = ext.getId();
	About about = ext.getAbout();
	String name = about == null || about.getName() == null ? id : about.getName();
	String icon = "Folder";
	String joust = "group = JoustMenu.addChildItem(" + parentNode + ", '" + icon + "', " + 
			"'" + HTML.javaScriptEncode(name) + "', 'extensionOnClick(\"" + id + "\")', " + 
			"'', '" + groupId + "')";
	return joust;
}
String getJoustPlugin(String parentNode, ExtensionsControl ex, PluginInfo info, ExtensionsFile ef)
{
	String id = info.getClassName();
	About about = info.getAbout();
	String name = about == null || about.getName() == null ? id : about.getName();
	if (info.getType() != null)
	{
		name += " <span class=\"itemref\">[" + info.getType().toString() + "]</span>";
	}
	String icon = info.isDisabled() ? "PluginDisabled" : "Plugin";
	if ((ef != null && ef.hasError()) || !info.isInstalled())
	{
		icon = "PluginError";
	}
	
	String joust = "plugin = JoustMenu.addChildItem(" + parentNode +", '" + icon + "', " + 
			"'" + HTML.javaScriptEncode(name) + "', 'pluginOnClick(\"" + id + "\")', " +
			"'', '" + id + "')";
	return joust;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	%>
	<base:page title="" type="iframe">
	<base:head scripts="newjoust.js" styles="newjoust.css">
	<script language="JavaScript">
	var isInitialised = false;
	function initialise() 
	{
		if (parent && parent.parent && parent.parent.adjustIFrameSize) parent.parent.adjustIFrameSize();
		var path = getRoot()+'images/joust/';
		IconStore.init();
		
		IconStore.addIcon('ExtensionPoint', path + 'extensionpoint.png');
		IconStore.addIcon('ExtensionPointSelected', path + 'extensionpointselected.png');
		IconStore.addIcon('ExtensionPointDisabled', path + 'extensionpointdisabled.png');
		IconStore.addIcon('ExtensionPointDisabledSelected', path + 'extensionpointdisabledselected.png');
		IconStore.addIcon('ExtensionPointError', path + 'extensionpointerror.png');
		IconStore.addIcon('ExtensionPointErrorSelected', path + 'extensionpointerrorselected.png');
		IconStore.addIcon('Extension', path + 'extension.png');
		IconStore.addIcon('ExtensionSelected', path + 'extensionselected.png');
		IconStore.addIcon('ExtensionDisabled', path + 'extensiondisabled.png');
		IconStore.addIcon('ExtensionDisabledSelected', path + 'extensiondisabledselected.png');
		IconStore.addIcon('ExtensionError', path + 'extensionerror.png');
		IconStore.addIcon('ExtensionErrorSelected', path + 'extensionerrorselected.png');
		IconStore.addIcon('Plugin', path + 'plugin.png');
		IconStore.addIcon('PluginSelected', path + 'pluginselected.png');
		IconStore.addIcon('PluginDisabled', path + 'plugindisabled.png');
		IconStore.addIcon('PluginDisabledSelected', path + 'plugindisabledselected.png');
		IconStore.addIcon('PluginError', path + 'pluginerror.png');
		IconStore.addIcon('PluginErrorSelected', path + 'pluginerrorselected.png');
		IconStore.addIcon('XmlFile', path + 'item.gif');
		IconStore.addIcon('XmlFileModified', path + 'itemmodified.gif');
		IconStore.addIcon('XmlFileError', path + 'itemerror.gif');
		IconStore.addIcon('XmlFileErrorModified', path + 'itemerrormodified.gif');
		IconStore.addIcon('XmlFileSelected', path + 'itemselected.gif');
		IconStore.addIcon('XmlFileModifiedSelected', path + 'itemmodifiedselected.gif');
		IconStore.addIcon('XmlFileErrorSelected', path + 'itemerrorselected.gif');
		IconStore.addIcon('XmlFileErrorModifiedSelected', path + 'itemerrormodifiedselected.gif');
		IconStore.addIcon('JarFile', path + 'jarfile.png');
		IconStore.addIcon('JarFileModified', path + 'jarfilemodified.png');
		IconStore.addIcon('JarFileError', path + 'jarfileerror.png');
		IconStore.addIcon('JarFileErrorModified', path + 'jarfileerrormodified.png');
		IconStore.addIcon('JarFileSelected', path + 'jarfileselected.png');
		IconStore.addIcon('JarFileModifiedSelected', path + 'jarfilemodifiedselected.png');
		IconStore.addIcon('JarFileErrorSelected', path + 'jarfileerrorselected.png');
		IconStore.addIcon('JarFileErrorModifiedSelected', path + 'jarfileerrormodifiedselected.png');

		var byExtPoint = JoustMenu.addMenuItem(-1, 'Root', 'By extension point', 'rootOnClick()', '', '');
		var toolbars = JoustMenu.addChildItem(byExtPoint, 'Folder', 'Toolbars');
		var editDialogs = JoustMenu.addChildItem(byExtPoint, 'Folder', 'Edit dialogs');
		var listColumns = JoustMenu.addChildItem(byExtPoint, 'Folder', 'List columns');
		var ep;
		var ext;
		var plugin;
		<%
		ExtensionsControl ec = ExtensionsControl.get(dc);
		List<ExtensionPoint<?>> extensionPoints = ec.getExtensionPoints();
		Collections.sort(extensionPoints, Registry.EXTENSIONPOINT_COMPARATOR);
		for (ExtensionPoint ep : extensionPoints)
		{
			String id = ep.getId();
			String parent = "byExtPoint";
			if (id.startsWith("net.sf.basedb.clients.web.toolbar.")) parent = "toolbars";
			if (id.startsWith("net.sf.basedb.clients.web.tabcontrol.edit.")) parent = "editDialogs";
			if (id.startsWith("net.sf.basedb.clients.web.onsave.")) parent = "editDialogs";
			if (id.startsWith("net.sf.basedb.clients.web.listcolumn.")) parent = "listColumns";
			%>
			<%=getJoustExtensionPoint(parent, ec, ep, ec.getFileByObjectKey(new ExtensionPointKey(ep)))%>
			<%
			List<Extension<?>> extensions = ec.getExtensions(ep.getId());
			Collections.sort(extensions, Registry.EXTENSION_COMPARATOR);
			for (Extension ext : extensions)
			{
				%>
				<%=getJoustExtension("ep", ec, ext, ec.getFileByObjectKey(new ExtensionKey(ext)), false, true)%>
				<%
			}
		}
		%>
		var byFile = JoustMenu.addMenuItem(-1, 'Root', 'By file', 'rootOnClick()');
		var file;
		var group;
		<%
		for (ExtensionsFile ef : ec.getFiles())
		{
			if (!ef.isInstalled()) continue;
			
			String efName = ef.getName();
			String icon = ef.isJar() ? "JarFile" : "XmlFile";
			if (ef.hasError()) icon += "Error";
			if (ef.checkModified()) icon += "Modified";
			String id = efName;
			%>
			file = JoustMenu.addChildItem(byFile, '<%=icon%>', '<%=HTML.javaScriptEncode(efName)%>', 'fileOnClick("<%=ef.getURI().toString()%>")', '', '<%=id%>');
			<%
			List<ExtensionPoint> eps = ef.getObjectsOfClass(ExtensionPoint.class);
			Collections.sort(eps, Registry.EXTENSIONPOINT_COMPARATOR);
			for (ExtensionPoint ep : eps)
			{
				%>
				<%=getJoustExtensionPoint("file", ec, ep, ef)%>
				<%
			}
			List<Extension> exts = ef.getObjectsOfClass(Extension.class);
			Collections.sort(exts, Registry.EXTENSION_COMPARATOR);
			String currentGroupId = null;
			for (Extension ext : exts)
			{
				int groupIndex = ext.getId().indexOf(":");
				// ID:s containing ':' should be grouped
				if (groupIndex > 0)
				{
					String groupId = ext.getId().substring(0, groupIndex);
					if (!groupId.equals(currentGroupId))
					{
						currentGroupId = groupId;
						%>
						<%=getExtensionGroup("file", ec, ext, currentGroupId)%>
						<%
					}
				}
				else
				{
					currentGroupId = null;
				}
				%>
				<%=getJoustExtension(currentGroupId == null ? "file" : "group", ec, ext, ef, currentGroupId != null, false)%>
				<%
			}
			List<PluginInfo> plugins = ef.getObjectsOfClass(PluginInfo.class);
			Collections.sort(plugins, PluginInfo.NAME_COMPARATOR);
			for (PluginInfo info : plugins)
			{
				%>
				<%=getJoustPlugin("file", ec, info, ef)%>
				<%
			}
		}
		%>
		JoustMenu.menuItems[byExtPoint].isOpen = true;
		JoustMenu.menuItems[byFile].isOpen = true;
		JoustMenu.draw('joust');
		isInitialised = true;
	}

	function openAll()
	{
		JoustMenu.openAll();
	}

	function closeAll()
	{
		JoustMenu.closeAll();
	}
	
	function setIcon(nodeId, iconName)
	{
		var icons = new Array();
		icons[nodeId] = iconName;
		setIconsByExternalId(icons);
	}
	
	function setChildIcons(parentNodeId, enable)
	{
		var node = JoustMenu.menuItems[parentNodeId];
		if (!node) return;
		var childNode = JoustMenu.menuItems[node.firstChildIndex];
		var icons = new Array();
		var numChildren = 0;
		while (childNode)
		{
			numChildren++;
			var iconName = childNode.iconName;
			var isDisabled = iconName.indexOf('Disabled') > 0; 
			if (enable && isDisabled)
			{
				iconName = iconName.replace('Disabled', '');
			}
			else if (!enable && !isDisabled)
			{
				iconName += 'Disabled';
			}
			icons[childNode.externalId] = iconName;
			childNode = JoustMenu.menuItems[childNode.nextItemIndex];
		}
		if (numChildren > 0) setIconsByExternalId(icons);
	}
	
	function setIconsByExternalId(icons)
	{
		for (var i = 0; i < JoustMenu.menuItems.length; i++)
		{
			var node = JoustMenu.menuItems[i];
			var iconName = icons[node.externalId];
			if (iconName)
			{
				node.iconName = iconName;
				JoustMenu.updateIconsAndText(node.index);
			}
		}
	}
	
	function selectFile(filename)
	{
		var fileNode = JoustMenu.menuItems[filename];
		if (fileNode)
		{
			JoustMenu.open(fileNode.index);
			JoustMenu.select(fileNode.index);
		}
	}
	
	function rootOnClick()
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>';
	}
	
	function extensionPointOnClick(extensionPointId)
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>&extensionPointId='+escape(extensionPointId);
	}
	function extensionOnClick(extensionId)
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>&extensionId='+escape(extensionId);
	}
	function fileOnClick(fileuri)
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>&fileuri='+escape(fileuri);	
	}
	function pluginOnClick(className)
	{
		parent.frames['details'].location.href = '../plugindefinitions/index.jsp?ID=<%=ID%>&cmd=ViewItemByClass&iframe=1&className='+escape(className);
	}
	</script>
	<style>
	.itemref 
	{
		font-size: 0.85em;
		color: #666666;
	}
	.selected .itemref 
	{
		color: #E8E8E8;
	}
	</style>
	</base:head>
		<base:body onload="initialise()">
		<div id="main" class="joust absolutefull" onmousemove="parent.DragDrop.drag(event)" onmouseup="parent.DragDrop.endDrag(event)">
			<div id="joust" style="overflow: auto; height: 100%; width: 100%;">
			</div>
		</div>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
