<%-- $Id: edit_agent.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.JOBAGENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	JobAgent agent = null;
	Integer port = null;

	final int selectedPluginId = Values.getInt(request.getParameter("plugin_id"), -1);

	// Query to retrieve installed plugins
	ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery();
	pluginQuery.include(Include.ALL);
	pluginQuery.order(Orders.asc(Hql.property("name")));

	if (itemId == 0)
	{
		title = "Create job agent";
		cc.removeObject("item");
		port = Values.getInteger(cc.getPropertyValue("port"), JobAgent.DEFAULT_PORT);
	}
	else
	{
		agent = JobAgent.getById(dc, itemId);
		cc.setObject("item", agent);
		title = "Edit job agent -- " + HTML.encodeTags(agent.getName());
		agent.checkPermission(Permission.WRITE);
		port = agent.getPort();
	}
		
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), agent);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Job agent" tab
		function validateJobAgent()
		{
			var frm = document.forms['agent'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.external_id.value) == '')
			{
				alert("You must enter an external ID");
				frm.external_id.focus();
				return false;
			}
			else if (Main.trimString(frm.port.value) != '')
			{
				var port = parseInt(frm.port.value);
				if (port < 1 || port > 65535)
				{
					alert("The port value must be between 1 and 65535");
					frm.port.focus();
					return false;
				}
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['agent'];
			if (TabControl.validateActiveTab('settings'))
			{
				var plugins = Link.getListIds(frm.plugins, 'P');
				for (var i = 0; i < plugins.length; i++)
				{
					var pluginId = plugins[i];
					var settings = getPluginSettings(pluginId);
					if (settings)
					{
						if (!settings.useDefaultMaxMemory)
						{
							Forms.createHidden(frm, 'maxMemory.'+pluginId, settings.maxMemory);
						}
						if (!settings.useDefaultTrusted)
						{
							Forms.createHidden(frm, 'trusted.'+pluginId, settings.trusted);
						}
						Forms.createHidden(frm, 'priorityBoost.'+pluginId, settings.priorityBoost);
					}
				}
				
				frm.allPlugins.value = plugins.join(',');
				frm.removePlugins.value = Link.getActionIds(-1, 'P').join(',');
				frm.submit();
			}
		}
		
		function addPluginsOnClick()
		{
			var plugins = Link.getListIds(document.forms['agent'].plugins, 'P');
			var url = '../plugindefinitions/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addPluginCallback';
			url += '&exclude='+plugins.join(',');
			Main.openPopup(url, 'AddPlugins', 1050, 700);
		}
		function addPluginCallback(pluginId, name)
		{
			var item = Link.getItem('P', pluginId);
			if (!item) item = new Item('P', pluginId, name);
			Link.addItem(document.forms['agent'].plugins, item);
			pluginsOnClick();
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['agent'].plugins);
			Main.hide('pluginsettings');
		}
		
		function initPlugins()
		{
			var plugins = document.forms['agent'].plugins;
			<%
			if (pluginQuery != null)
			{
				ItemResultList<PluginDefinition> plugins = pluginQuery.list(dc);
				for (PluginDefinition plugin : plugins)
				{
					// Default settings
					boolean defaultTrusted = plugin.isTrusted();
					Long defaultMaxMemory = plugin.getMaxMemory();

					// Specific settings
					JobAgentSettings settings = agent == null ? null : agent.getSettings(plugin, false);
					Boolean trusted = null;
					Long maxMemory = null;
					int priorityBoost = 0;
					if (settings != null)
					{
						trusted = settings.isTrusted();
						maxMemory = settings.getMaxMemory();
						priorityBoost = settings.getPriorityBoost();
						%>
						Link.addNewItem(plugins, new Item('P', <%=plugin.getId()%>, '<%=HTML.javaScriptEncode(plugin.getName())%>'));
						<%
					}
					%>
					new PluginSetting(<%=plugin.getId()%>, '<%=trusted == null ? "" : trusted ? "1" : "0"%>', '<%=defaultTrusted ? "1" : "0"%>', '<%=Values.formatBytes(maxMemory)%>', '<%=Values.formatBytes(defaultMaxMemory)%>', '<%=priorityBoost%>');
					<%
				}
			}
			%>
		}
		
		function selectPlugin(pluginId)
		{
			var frm = document.forms['agent'];
			for (var i = 0; i < frm.plugins.length; i++)
			{
				if (frm.plugins[i].item.id == pluginId)
				{
					frm.plugins.selectedIndex = i;
					pluginsOnClick();
					return;
				}
			}
		}
			
		function init()
		{
			<%
			if (agent == null)
			{
				%>
				var frm = document.forms['agent'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initPlugins();
			<%
			if (selectedPluginId != -1)
			{
				%>
				selectPlugin(<%=selectedPluginId%>);
				<%
			}
			%>
		}
		
		var selectedPluginId;
		function pluginsOnClick()
		{
			var frm = document.forms['agent'];
			var pluginId = frm.plugins[frm.plugins.selectedIndex].item.id;
			var settings = getPluginSettings(pluginId);
			if (settings)
			{
				Main.show('pluginsettings');
				selectedPluginId = pluginId;
				// Set max memory
				frm.useDefaultMaxMemory.checked = settings.useDefaultMaxMemory;
				useDefaultMaxMemoryOnClick();
				var defaultMaxMemory = document.getElementById("defaultMaxMemory");
				defaultMaxMemory.innerHTML = settings.defaultMaxMemory;
				
				// Set trusted
				Forms.checkRadio(frm.trusted, settings.trusted);
				var defaultTrusted = document.getElementById("defaultTrusted");
				defaultTrusted.innerHTML = settings.defaultTrusted == '0' ? 'no' : 'yes';

				// Set priority boost
				frm.priorityBoost.value = settings.priorityBoost;
			}
			else
			{
				Main.hide('pluginsettings');
			}
		}
		
		function priorityBoostOnBlur()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var priorityBoost = parseInt(frm.priorityBoost.value);
				if (priorityBoost < 0 || priorityBoost > 10)
				{
					alert('The priority boost must be between 0 and 10');
					frm.priorityBoost.focus();
					return;
				}
				settings.priorityBoost = priorityBoost;
			}
		}
		
		function useDefaultMaxMemoryOnClick()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var useDefault = frm.useDefaultMaxMemory.checked;
				settings.useDefaultMaxMemory = useDefault;
				frm.maxMemory.disabled = useDefault;
				if (!useDefault) 
				{
					frm.maxMemory.focus();
					frm.maxMemory.value = settings.maxMemory;
				}
			}
		}
		
		function maxMemoryOnBlur()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				settings.maxMemory = frm.maxMemory.value;
			}
		}
		
		function trustedOnClick()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var selected = Forms.getCheckedRadio(frm.trusted);
				if (selected != null)
				{
					settings.trusted = selected.value;
					settings.useDefaultTrusted = settings.trusted == '';
				}
			}
		}

		
		function getPluginSettings(pluginId)
		{
			return allPluginSettings['P'+pluginId];
		}
		
		var allPluginSettings = new Array();
		function PluginSetting(pluginId, trusted, defaultTrusted, maxMemory, defaultMaxMemory, priorityBoost)
		{
			this.pluginId = pluginId;
			this.trusted = trusted;
			this.defaultTrusted = defaultTrusted;
			this.useDefaultTrusted = trusted != null;
			this.maxMemory = maxMemory;
			this.defaultMaxMemory = defaultMaxMemory == '' ? 'not specified' : defaultMaxMemory;
			this.useDefaultMaxMemory = (maxMemory == '');
			this.priorityBoost = priorityBoost;
			allPluginSettings['P'+pluginId] = this;
		}
		
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="agent" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=agent != null%>" active="<%=selectedPluginId == -1 ? null : "plugins" %>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Job agent" validate="validateJobAgent()" helpid="jobagent.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(agent == null ? Values.getString(cc.getPropertyValue("name"), "New job agent") : agent.getName())%>" 
					maxlength="<%=JobAgent.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External Id</th>
				<td><input <%=requiredClazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(agent == null ? cc.getPropertyValue("externalId") : agent.getExternalId())%>" 
					maxlength="<%=JobAgent.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Server</th>
				<td><input <%=clazz%> type="text" name="server" 
					value="<%=HTML.encodeTags(agent == null ? cc.getPropertyValue("server") : agent.getServer())%>" 
					maxlength="<%=JobAgent.MAX_SERVER_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Port</th>
				<td><input <%=clazz%> type="text" name="port" 
					value="<%=port == null ?  "" : port.toString() %>" 
					maxlength="10" style="width: 15em;"
					onkeypress="return Numbers.integerOnly(event)">
					<span class="link" onclick="document.forms['agent'].port.value = '<%=JobAgent.DEFAULT_PORT%>'"
						>Use default (<%=JobAgent.DEFAULT_PORT%>)</span>
					</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(agent == null ? cc.getPropertyValue("description") : agent.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'agent', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="plugins" title="Plugins" helpid="jobagent.plugins">
			<table class="fullform input100 smaller">
			<tr class="big">
				<th>Installed plugins</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="plugins" size="12" multiple onclick="pluginsOnClick()">
								</select>
								<input type="hidden" name="removePlugins" value="">
								<input type="hidden" name="allPlugins" value="">
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										subclass="leftaligned"
										onclick="addPluginsOnClick()" 
										title="Add&nbsp;plugins&hellip;"  
										tooltip="Add plugins to this job agent"
									/>
									<base:button 
										subclass="leftaligned"
										onclick="removeOnClick()" 
										title="Remove" 
										tooltip="Remove the selected plugins"
									/>
								</base:buttongroup>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			<tbody id="pluginsettings" style="display: none;">
				<tr>
					<th colspan="2" class="bottomborder" style="border-top: 1px solid #A0A0A0;">Settings for the selected plug-in</th>
				</tr>
				<tr>
					<th class="subprompt">Max memory</th>
					<td>
						<input type="text" name="maxMemory" class="text" style="width: 15em;"
							maxlength="16"	onblur="maxMemoryOnBlur()">
							(Use KB, MB or GB to specify memory)
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>
						<input type="checkbox" name="useDefaultMaxMemory" id="useDefaultMaxMemory"
							onclick="useDefaultMaxMemoryOnClick()">
						<label for="useDefaultMaxMemory">Use default</label> (<span id="defaultMaxMemory"></span>)
					</td>
				</tr>
				<tr>
					<th class="subprompt">Trusted</th>
					<td>
						<input type="radio" name="trusted" id="trustedDefault" value="" 
							onclick="trustedOnClick()"><label for="trustedDefault">default (<span id="defaultTrusted"></span>)</label>
						<input type="radio" name="trusted" id="trustedYes" value="1"
							onclick="trustedOnClick()"><label for="trustedYes">yes</label>
						<input type="radio" name="trusted" id="trustedNo" value="0"
							onclick="trustedOnClick()"><label for="trustedNo">no</label>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Priority boost</th>
					<td>
						<input type="text" name="priorityBoost" class="text" style="width: 15em;"
							maxlength="10" onkeypress="return Numbers.integerOnly(event)"
							onblur="priorityBoostOnBlur()">
					</td>
				</tr>
			</tbody>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
