<%-- $Id: edit_news.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.NEWS;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	News news = null;
	Date startDate = null;
	Date newsDate = null;

	if (itemId == 0)
	{
		title = "Create news";
		cc.removeObject("item");
		startDate = (Date)cc.getPropertyObject("startDate");
		newsDate = (Date)cc.getPropertyObject("newsDate");
	}
	else
	{
		news = News.getById(dc, itemId);
		cc.setObject("item", news);
		title = "Edit news -- " + HTML.encodeTags(news.getName());
		startDate = news.getStartDate();
		newsDate = news.getNewsDate();
	}
	if (news != null && !news.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), news);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "News" tab
		function validateNews()
		{
			var dateFormat = '<%=jsDateFormat%>';
			var frm = document.forms['news'];
			if (Main.trimString(frm.title.value) == '')
			{
				alert("You must enter a title");
				frm.title.focus();
				return false;
			}
			else if (!Dates.isDate(frm.start_date.value, dateFormat))
			{
				alert("'"+frm.start_date.value+"' is not a valid value for start date");
				frm.start_date.focus();
				return false;
			}
			else if (!Dates.isDate(frm.news_date.value, dateFormat))
			{
				alert("'"+frm.news_date.value+"' is not a valid value for news date");
				frm.start_date.focus();
				return false;
			}
			else if (frm.end_date.value != '' && !Dates.isDate(frm.end_date.value, dateFormat))
			{
				alert("'"+frm.end_date.value+"' is not a valid value for end date");
				frm.start_date.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['news'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (news == null)
			{
				%>
				var frm = document.forms['news'];
				frm.title.focus();
				frm.title.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="news" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=news != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="News" validate="validateNews()" helpid="news.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Title</th>
				<td><input <%=requiredClazz%> type="text" name="title" 
					value="<%=HTML.encodeTags(news == null ? Values.getString(cc.getPropertyValue("name"), "New news") : news.getName())%>" 
					maxlength="<%=News.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Start date</th>
				<td>
					<table>
					<tr>
					<td>
						<input <%=requiredClazz%> type="text" name="start_date" style="width: 15em;"
						value="<%=HTML.encodeTags(dateFormatter.format(startDate == null ? new Date() : startDate))%>"
						maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:button 
							onclick="<%="Dates.selectDate('Start date', 'news', 'start_date', null, '"+jsDateFormat+"')"%>" 
							image="calendar.png"
							title="Calendar&hellip;" 
							tooltip="Select a date from a calendar" 
						/>
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>News date</th>
				<td>
					<table>
					<tr>
					<td>
						<input <%=requiredClazz%> type="text" name="news_date" style="width: 15em;"
						value="<%=HTML.encodeTags(dateFormatter.format(newsDate == null ? new Date() : newsDate))%>"
						maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:button 
							onclick="<%="Dates.selectDate('News date', 'news', 'news_date', null, '"+jsDateFormat+"')"%>" 
							image="calendar.png"
							title="Calendar&hellip;" 
							tooltip="Select a date from a calendar" 
						/>
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>End date</th>
				<td>
					<table>
					<tr>
					<td>
						<input <%=clazz%> type="text" name="end_date" style="width: 15em;"
						value="<%=dateFormatter.format(news == null ? 
								(Date)cc.getPropertyObject("endDate") : news.getEndDate())%>" 
						maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:button 
							onclick="<%="Dates.selectDate('End date', 'news', 'end_date', null, '"+jsDateFormat+"')"%>" 
							image="calendar.png"
							title="Calendar&hellip;" 
							tooltip="Select a date from a calendar" 
						/>
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4"name="description" 
						><%=HTML.encodeTags(news == null ? cc.getPropertyValue("description") : news.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'news', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
