<%-- $Id: index.jsp 6045 2012-04-03 12:23:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.util.FileUtil"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.RegexpFileFilter"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.WebException"	
	import="net.sf.basedb.clients.web.plugins.ItemQueryLoader"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.plugins.PluginConfigurationImporter"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.manager.PluginInfoKey"
	import="net.sf.basedb.util.extensions.xml.PluginInfo"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.LinkedHashMap"
	import="java.util.HashMap"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Collections"
	import="java.io.FileFilter"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,pluginType,className,description");
	private static final Item itemType = Item.PLUGINDEFINITION;
	
	private static void registerExportUtils(ItemContext cc)
	{
		// Register formatters
		cc.setObject("export.formatter.&configurations(name)", new NameableFormatter());
		
		// Register dataloaders
		String pluginParameter = "plugin";
		ItemQuery<PluginConfiguration> configQuery = PluginConfiguration.getQuery();
		configQuery.include(cc.getInclude());
		configQuery.restrict(Restrictions.eq(Hql.property("pluginDefinition"), Expressions.parameter("plugin")));
		configQuery.order(Orders.asc(Hql.property("name"))); 
		cc.setObject("export.dataloader.&configurations(name)", new ItemQueryLoader(configQuery, pluginParameter));
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_plugins.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_plugin.jsp?ID="+ID+"&iframe=" + Values.getBoolean(request.getParameter("iframe"));
final String editPage = "edit_plugin.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("ViewItemByClass".equals(cmd))
	{
		dc = sc.newDbControl();
		PluginDefinition plugin = PluginDefinition.getByClassName(dc, request.getParameter("className"));
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(plugin.getId());
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		
		redirect = editPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		dc = sc.newDbControl();
		PluginDefinition plugin = (PluginDefinition)cc.getObject("item");
		String className = Values.getStringOrNull(request.getParameter("className"));
		String jarFile = Values.getStringOrNull(request.getParameter("jarFile"));
		int usePermissions = Values.getInt(request.getParameter("use_permissions"));
		if (plugin == null)
		{
			plugin = PluginDefinition.getNew(dc, className, jarFile, usePermissions == 2);
			message = "Plugin created";
			dc.saveItem(plugin);
		}
		else
		{
			dc.reattachItem(plugin, false);
			plugin.loadPluginInformation(jarFile, className, usePermissions == 2);
			message = "Plugin updated";
		}
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.PLUGINDEFINITION), plugin);
		ExtensionsInvoker invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			plugin.setMaxMemory(Values.parseBytes(request.getParameter("maxMemory"), null));
			plugin.setTrusted(Values.getBoolean(request.getParameter("trusted")));
			plugin.setUseInternalJobQueue(Values.getBoolean(request.getParameter("use_internal_jobqueue")));
			String aie = Values.getStringOrNull(request.getParameter("allow_immediate_execution"));
			plugin.setAllowImmediateExecution(aie == null ? 
				plugin.getMainType() == Plugin.MainType.EXPORT : Values.getBoolean(aie));
	
			//Update permissions
			ItemQuery<RoleKey> q = RoleKey.getQuery();
			q.setCacheResult(true);
			ItemResultList<RoleKey> roleKeys = q.list(dc);
			for (RoleKey key : roleKeys)
			{
				String name = key.getItemType().name();
				int granted = Values.getInt(request.getParameter(name+"_granted"));
				int denied = Values.getInt(request.getParameter(name+"_denied"));
				plugin.setPermissions(key, PermissionUtil.getPermissions(granted), PermissionUtil.getPermissions(denied));
			}
			plugin.setUsePermissions(usePermissions != 0);
			
			// Installed on job agents
			String[] removeAgents = Values.getString(request.getParameter("removeAgents")).split(",");
			for (int i = 0; i < removeAgents.length; ++i)
			{
				int agentId = Values.getInt(removeAgents[i], -1);
				if (agentId != -1) 
				{
					JobAgent agent = JobAgent.getById(dc, agentId);
					JobAgentSettings settings = agent.getSettings(plugin, false);
					if (settings != null && settings.isInDatabase()) dc.deleteItem(settings);
				}
			}
	
			String[] allAgents = Values.getString(request.getParameter("allAgents")).split(",");
			for (int i = 0; i < allAgents.length; ++i)
			{
				int agentId = Values.getInt(allAgents[i], -1);
				if (agentId != -1) 
				{
					JobAgent agent = JobAgent.getById(dc, agentId);
					JobAgentSettings settings = agent.getSettings(plugin, true);
					if (!settings.isInDatabase()) 
					{
						dc.saveItem(settings);
					}
					else
					{
						dc.reattachItem(settings, false);
					}
					//settings.setJarPath(Values.getStringOrNull(request.getParameter("jarPath."+agentId)));
					settings.setMaxMemory(Values.parseBytes(request.getParameter("maxMemory."+agentId), null));
					settings.setPriorityBoost(Values.getInt(request.getParameter("priorityBoost."+agentId)));
					String trusted = request.getParameter("trusted."+agentId);
					settings.setTrusted(trusted == null ? null : Values.getBoolean(trusted));
				}
			}
			
			//Annotations
			Base.updateAnnotations(dc, plugin, plugin, request);
			
			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("DisableItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		PluginDefinition plugin = PluginDefinition.getById(dc, cc.getId());
		plugin.setDisabled(true);
		ExtensionsControl ec = ExtensionsControl.get(dc);
		PluginInfo info = ec.getObjectForKey(new PluginInfoKey(plugin.getClassName()));
		if (info != null) info.setDisabled(true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("EnableItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		PluginDefinition plugin = PluginDefinition.getById(dc, cc.getId());
		plugin.setDisabled(false);
		ExtensionsControl ec = ExtensionsControl.get(dc);
		PluginInfo info = ec.getObjectForKey(new PluginInfoKey(plugin.getClassName()));
		if (info != null) info.setDisabled(false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<PluginDefinition> query = PluginDefinition.getQuery();
		query.join(Hql.leftJoin("guiContexts", "ctx"));
		query.setDistinct(true);
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		registerExportUtils(cc);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer(cc));
		dc.close();
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+plugins";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		registerExportUtils(cc);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+plugin";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<PluginDefinition> query = PluginDefinition.getQuery();
		query.join(Hql.leftJoin("guiContexts", "ctx"));
		query.setDistinct(true);
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+plugins";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+plugin";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<PluginDefinition> query = PluginDefinition.getQuery();
		query.join(Hql.leftJoin("guiContexts", "ctx"));
		query.setDistinct(true);
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("UnloadItems".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		dc = sc.newDbControl();
		for (int id : cc.getSelected())
		{
			PluginDefinition pd = PluginDefinition.getById(dc, id);
			if (pd.getJarPath() != null)
			{
				JarClassLoader.unload(pd.getJarPath());
			}
		}
		dc.close();
		redirect = listPage;
	}
	else if ("UnloadItem".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		dc = sc.newDbControl();
		PluginDefinition pd = PluginDefinition.getById(dc, cc.getId());
		if (pd.getJarPath() != null)
		{
			JarClassLoader.unload(pd.getJarPath());
		}
		dc.close();
		redirect = viewPage;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

