<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.ClonableProperty"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.REPORTERCLONETEMPLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ReporterCloneTemplate template = null;
	List<ClonableProperty> clonableProperties = null;
	
	if (itemId == 0)
	{
		title = "Create reporter clone template";
		clonableProperties = ClonableProperty.getAllMandatory();
		cc.removeObject("item");
	}
	else
	{
		template = ReporterCloneTemplate.getById(dc, itemId);
		template.checkPermission(Permission.WRITE);
		clonableProperties = template.getClonableProperties();
		cc.setObject("item", template);
		title = "Edit reporter clone template -- " + HTML.encodeTags(template.getName());
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), template);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Template" tab
		function validateTemplate()
		{
			var frm = document.forms['template'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['template'];
			if (TabControl.validateActiveTab('settings'))
			{
				for (var i = 0; i < frm.cloned_properties.length; i++)
				{
					frm.cloned_properties[i].selected = true;
				}
				for (var i = 0; i < frm.uncloned_properties.length; i++)
				{
					frm.uncloned_properties[i].selected = true;
				}
				frm.submit();
			}
		}	

		function init()
		{
			var frm = document.forms['template'];
			<%
			if (template == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		
		function moveBetween(list1, list2, exceptMandatory)
		{
			var moved = 0;
			for(i=0; i < list1.options.length; i++) // >
			{
				if (list1.options[i].selected)
				{
					if (exceptMandatory && list1.options[i].text.indexOf('×') > 0)
					{
						alert(list1.options[i].text + ' is mandatory');
					}
					else
					{
						moved++;
						list2.options[list2.options.length] = new Option(list1.options[i].text, list1.options[i].value, false, true);
						list1.options[i] = null;
						i--;
					}
				}
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="template" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=template != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Reporter clone template" validate="validateTemplate()" helpid="reporterclonetemplate.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(template == null ? Values.getString(cc.getPropertyValue("name"), "New reporter clone template") : template.getName())%>" 
					maxlength="<%=ReporterCloneTemplate.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Properties</th>
				<td>
					<table style="width: 100%;">
					<tr>
						<td style="width: 47%;">
							<b>Cloned</b><br>
							<select name="cloned_properties" multiple size="12" style="width: 100%;" 
								ondblclick="moveBetween(document.forms['template'].cloned_properties, document.forms['template'].uncloned_properties, true)">
							<%
							for (ClonableProperty cp : clonableProperties)
							{
								%>
								<option value="<%=cp.getName()%>" 
									style="<%=cp.isMandatory() ? "font-weight: bold;" : "" %>
									title="<%=HTML.encodeTags(cp.getDescription())%>"><%=HTML.encodeTags(cp.getTitle())%><%=cp.isMandatory() ? " ×" : ""%>
								<%
							}
							%>
							</select>
						</td>
						
						<td style="vertical-align: middle; padding: 5px;" style="width: 6%;">
						   <base:buttongroup vertical="true">
								<base:button
									onclick="moveBetween(document.forms['template'].uncloned_properties, document.forms['template'].cloned_properties)" 
									image="move_left.png"
									tooltip="Clone the selected uncloned properties" 
									subclass="square"
								/>
								<base:button 
									onclick="moveBetween(document.forms['template'].cloned_properties, document.forms['template'].uncloned_properties, true)" 
									image="move_right.png" 
									tooltip="Do not cloned the selected properties" 
									subclass="square"
								/>
							</base:buttongroup>
						</td>
						
						<td style="width: 47%;">
							<b>Not cloned</b><br>
							<select name="uncloned_properties" multiple size="12" style="width: 100%;" 
								ondblclick="moveBetween(document.forms['template'].uncloned_properties, document.forms['template'].cloned_properties)">
							<%
							for (ClonableProperty cp : ClonableProperty.getAll())
							{
								if ((template == null && !cp.isMandatory()) || (template != null && !template.hasClonableProperty(cp.getName())))
								{
									%>
									<option value="<%=cp.getName()%>" title="<%=HTML.encodeTags(cp.getDescription())%>"><%=HTML.encodeTags(cp.getTitle())%>
									<%
								}
							}
							%>
							</select>
						</td>
						
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(template == null ? cc.getPropertyValue("description") : template.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'template', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
