<%-- $Id: submit_server.jsp 6072 2012-07-30 12:56:10Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.ClientDefaultSetting"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.servlet.RssNewsFeed"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
String cmd = request.getParameter("cmd");
String root = request.getContextPath()+"/";

String forward = null;
String redirect = null;
String message = null;

DbControl dc = sc.newDbControl();
try
{
	if ("SaveSettings".equals(cmd))
	{
		Client server = Client.getById(dc, sc.getClientId());

		// File transfer tab
		ClientDefaultSetting transferRateUpload = server.getDefaultSetting("server.transferRate");
		boolean unlimitedUpload = Values.getBoolean(request.getParameter("unlimited_upload"));
		String rateUpload = Values.getStringOrNull(request.getParameter("transfer_rate_upload"));
		if (!unlimitedUpload && rateUpload != null)
		{
			Long bytes = Values.parseBytes(rateUpload, null);
			if (bytes == null)
			{
				throw new WebException("popup", "Invalid byte value", "The value {1} is not a valid value.", rateUpload);
			}
			rateUpload = bytes.toString();
		}
		transferRateUpload.setValue(rateUpload == null ? "0" : rateUpload);

		ClientDefaultSetting transferRateDownload = server.getDefaultSetting("server.transferRate.download");
		boolean unlimitedDownload = Values.getBoolean(request.getParameter("unlimited_download"));
		String rateDownload = Values.getStringOrNull(request.getParameter("transfer_rate_download"));
		if (!unlimitedDownload && rateDownload != null)
		{
			Long bytes = Values.parseBytes(rateDownload, null);
			if (bytes == null)
			{
				throw new WebException("popup", "Invalid byte value", "The value {1} is not a valid value.", rateDownload);
			}
			rateDownload = bytes.toString();
		}
		transferRateDownload.setValue(rateDownload == null ? "0" : rateDownload);

		
		// About tab
		ClientDefaultSetting adminName = server.getDefaultSetting("server.admin.name");
		ClientDefaultSetting adminEmail = server.getDefaultSetting("server.admin.email");
		ClientDefaultSetting about = server.getDefaultSetting("server.about");
		adminName.setValue(Values.getString(request.getParameter("name")));
		adminEmail.setValue(Values.getString(request.getParameter("email")));
		about.setValue(Values.getString(request.getParameter("about")));

		// Get account tab
		ClientDefaultSetting getAccount = server.getDefaultSetting("server.get.account");
		getAccount.setValue(Values.getString(request.getParameter("account")));

		// Forgotten password tab
		ClientDefaultSetting forgottenPassword = server.getDefaultSetting("server.forgotten.password");
		forgottenPassword.setValue(Values.getString(request.getParameter("password")));

		//Links tab
		ClientDefaultSetting helplink = server.getDefaultSetting("server.links.help");
		ClientDefaultSetting faqlink = server.getDefaultSetting("server.links.faq");
		ClientDefaultSetting reportbuglink = server.getDefaultSetting("server.links.reportbug");
		helplink.setValue(Values.getString(request.getParameter("help")));
		faqlink.setValue(Values.getString(request.getParameter("faq")));
		reportbuglink.setValue(Values.getString(request.getParameter("reportbug")));
	
		dc.commit();
		sc.reloadSettings(true, false);
		message = "Settings saved";
	}
	else if ("RestartServer".equals(cmd))
	{
		Application.stop();
		Application.start();
		message = "The server has been restarted. You must log in again.";
	}
	else if ("SetBroadcastMessage".equals(cmd))
	{
		String title = Values.getStringOrNull(request.getParameter("title"));
		String broadcastMessage = Values.getStringOrNull(request.getParameter("message"));
		boolean denyLogin = Values.getBoolean(request.getParameter("denyLogin"));
		
		if (title != null)
		{
			application.setAttribute("broadcast.title", title);
			application.setAttribute("broadcast.message", broadcastMessage);
			application.setAttribute("broadcast.deny-login", denyLogin);
			message = "Message is now sent";
		}
		else
		{
			application.removeAttribute("broadcast.title");	
			application.removeAttribute("broadcast.message");	
			application.removeAttribute("broadcast.deny-login");	
			message = "Message is now disabled";
		}
		RssNewsFeed.reset();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}
if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

