<%-- $Id: annotate.jsp 6283 2013-05-29 11:46:56Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	
	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.AnnotatableProxy"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.NameableComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.TreeSet"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final int protocolId = Values.getInt(request.getParameter("protocol_id"), -1);
final int subtypeId = Values.getInt(request.getParameter("subtype_id"), -1);
final int annotationTypeId = Values.getInt(request.getParameter("annotationtype_id"));
final boolean standalone = Values.getBoolean(request.getParameter("standalone"));

final DbControl dc = sc.newDbControl();
Set<AnnotationType> annotationTypes = null;
Set<AnnotationType> protocolParameters = null;
Map<AnnotationType, Annotation> existing = null;
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);

	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String jsDateTimeFormat = HTML.javaScriptEncode(dateTimeFormat);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);
	
	final Annotatable item = itemId == 0 ? null : (Annotatable)itemType.getById(dc, itemId);
	final boolean writePermission = item == null ? true : item.hasPermission(Permission.WRITE);
	Protocol protocol = null;
	boolean readProtocol = true;
	try
	{
		if (protocolId == - 1 && item != null)
		{
			protocol = item.getProtocol();
		}
		else if (protocolId > 0)
		{
			protocol = Protocol.getById(dc, protocolId);
		}
	}
	catch (PermissionDeniedException ex)
	{
		readProtocol = false;
	}
	String selectedCategoryName = null;
	try
	{
		ItemSubtype subtype = null;
		if (subtypeId > 0)
		{
			subtype = ItemSubtype.getById(dc, subtypeId);
		}
		else if (item instanceof Subtypable)
		{
			subtype = ((Subtypable)item).getItemSubtype();
		}
		else if (item instanceof BioPlate)
		{
			BioPlateType bpt = ((BioPlate)item).getBioPlateType();
			subtype = bpt.getItemSubtype();
			if (subtype == null) selectedCategoryName = bpt.getName();
		}
		if (subtype != null) selectedCategoryName = subtype.getName();
	}
	catch (PermissionDeniedException ex)
	{}
	
	if (standalone)
	{
		sc.getCurrentContext(itemType).setObject("item", item);	
	}
	final String clazz = "class=\"text\"" ;

	String title = "Annotate " + 
		HTML.encodeTags((item instanceof Nameable ? ((Nameable)item).getName() : 
			(item == null ? " new item" : item.toString())));

	// Queries to retrieve annotation types and protocol parameters
	boolean isProxy = item instanceof AnnotatableProxy;
	ItemQuery<AnnotationType> annotationTypeQuery = null;
	String message = null;

	if (isProxy)
	{
		AnnotatableProxy proxy = (AnnotatableProxy)item;
		annotationTypeQuery = Base.getAnnotationTypesQuery(proxy);
		message = proxy.getAnnotationMessage();
	}
	else
	{
		annotationTypeQuery = Base.getAnnotationTypesQuery(itemType, false);
	}
	final ItemQuery<AnnotationType> parameterQuery = Base.getProtocolParametersQuery(protocol);

	// Query to retrieve the categories of an annotation type
	final ItemQuery<AnnotationTypeCategory> categoryQuery = AnnotationTypeCategory.getQuery();
	categoryQuery.include(Include.MINE, Include.OTHERS, Include.SHARED, Include.IN_PROJECT);
	categoryQuery.join(Hql.innerJoin("annotationTypes", "atp"));
	categoryQuery.restrict(Restrictions.eq(Hql.alias("atp"), Expressions.parameter("annotationType")));

	// Holds all categories that we have found
	final Set<AnnotationTypeCategory> allCategories = 
		new TreeSet<AnnotationTypeCategory>(new NameableComparator(false));
	
	final StringBuilder sb = new StringBuilder();
	final AnnotationSet as = item == null || !item.isAnnotated() ? null : item.getAnnotationSet();
	if (as != null)
	{
		// Load the existing annotations
		existing = new HashMap<AnnotationType, Annotation>();
		List<Annotation> annotations = as.getAnnotations().list(dc);
		for (Annotation a : annotations)
		{
			try
			{
				existing.put(a.getAnnotationType(), a);
			}
			catch (PermissionDeniedException ex)
			{}
		}
	}
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="annotations.js,parameters.js" styles="parameters.css">
	<script language="JavaScript">
	function init()
	{
		<%
		annotationTypes = new TreeSet<AnnotationType>(new NameableComparator(false));
		annotationTypes.addAll(annotationTypeQuery.list(dc));
		if (existing != null) annotationTypes.addAll(existing.keySet());
		if (annotationTypeId != 0)
		{
			annotationTypes.add(AnnotationType.getById(dc, annotationTypeId));
		}
		if (parameterQuery != null) 
		{
			protocolParameters = new HashSet<AnnotationType>(parameterQuery.list(dc));
			annotationTypes.addAll(protocolParameters);
		}
		for (AnnotationType at : annotationTypes)
		{
			boolean isParameter = protocolParameters != null && protocolParameters.contains(at);
			String fullLabel = HTML.encodeTags(at.getName());
			String label = (isParameter ? "<img src=\"../../images/parameter.png\">" : "") +  fullLabel;
			List values = null;
			Unit unit = at.getDefaultUnit();
			Type valueType = at.getValueType();
			if (existing != null && existing.containsKey(at))
			{
				Annotation a = existing.get(at);
				unit = a.getUnit();
				values = a.getValues(null);
			}
			if (at.isRemoved() && values == null) continue;
			categoryQuery.setParameter("annotationType", at.getId(), Type.INT);
			%>
			var values = new Array();
			var categories = new Array();
			<% 
			if (values != null)
			{
				for (Object value : values)
				{
					if (value instanceof Date) 
					{
						if (valueType == Type.TIMESTAMP)
						{
							value = dateTimeFormatter.format((Date)value);
						}
						else
						{
							value = dateFormatter.format((Date)value);
						}
					}
					%>
					values[values.length] = '<%=HTML.javaScriptEncode(value.toString())%>';
					<%
				}
			}
			boolean checkCategoryNameAgainstSubtype = at.getId() == annotationTypeId;
			boolean foundCategoryForSubtype = false;
			for (AnnotationTypeCategory category : categoryQuery.list(dc))
			{
				if (checkCategoryNameAgainstSubtype)
				{
					if (category.getName().equals(selectedCategoryName)) foundCategoryForSubtype = true;
				}
				allCategories.add(category);
				%>
				categories[categories.length] = <%=category.getId()%>;
				<%
			}
			if (checkCategoryNameAgainstSubtype && !foundCategoryForSubtype) selectedCategoryName = null;

			String icon = "";
			if (values != null && values.size() > 0)
			{
				icon = "notrequired_values.gif";
			}
			else
			{
				icon = "notrequired_novalues.gif";
			}
			String deleted = at.isRemoved() ? "<img src=\"../../images/deleted.png\">" : "";
			icon = "<span class=\"icon\"><img id=\"icon_"+at.getId()+"\" src=\"../../images/"+icon+"\"></span>";
			sb.append("<div class=\"param\" id=\"prompt_"+at.getId()+"\" onclick=\"parametersOnClick('"+at.getId()+"')\"");
			sb.append(" title=\""+fullLabel+"\">");
			sb.append(icon+"<span class=\"label\">"+deleted+label+"</span></div>\n");
			%>
			var at = new Parameter('<%=at.getId()%>', '<%=HTML.javaScriptEncode(at.getName())%>', <%=at.getMultiplicity()%>, <%=at.isEnumeration()%>, false, values, <%=unit != null ? unit.getId() : 0%>);
			at.categories = categories;
			at.isParameter = <%=isParameter ? "true" : "false" %>;
			<%
		}
		%>
		<%
		if (annotationTypeId != 0)
		{
			%>
			parametersOnClick(<%=annotationTypeId%>);
			<%
		}
		%>
		categoryOnChange();
	}

		function categoryOnChange()
		{
			var frm = document.forms['annotations'];
			var categoryId = frm.categories[frm.categories.selectedIndex].value;
			for (var i = 0; i < Parameters.allParameters.length; i++)
			{
				var pp = Parameters.allParameters[i];
				var show = false;
				if (categoryId == -1)
				{
					// show all
					show = true;
				}
				else if (categoryId == -2 && pp.isParameter)
				{
					show = true;
				}
				else if (categoryId == 0 && pp.categories.length == 0 && !pp.isParameter)
				{
					// show uncategorized
					show = true;
				}
				else
				{
					for (var j = 0; j < pp.categories.length; j++)
					{
						if (pp.categories[j] == categoryId) show = true;
					}
				}
				var div = 'prompt_'+pp.name;
				if (show)
				{
					Main.show(div);
				}
				else
				{
					Main.hide(div);
				}
			}
		}
	
		var oldValueDiv;
		function parametersOnClick(parameterId)
		{
			var frm = document.forms['annotations'];
			if (oldValueDiv) Main.hide(oldValueDiv);
			
			var pp = Parameters.allParameters['ID'+parameterId];
			setSelectedParameter(pp, parameterId);
			oldValueDiv = 'value_'+pp.name+'_div'
			Main.show(oldValueDiv);
			
			var valueElement = frm['value_'+pp.name];
			if (valueElement.focus) valueElement.focus();
			if (pp.enumeration)
			{
				Main.hide('valuecontainer');
				if (valueElement.type && valueElement.type.search('select') != -1)
				{
					// selection list
					Forms.selectListOptions(valueElement, pp.values);
				}
				else if (pp.multiplicity == 1)
				{
					// radio buttons
					Forms.checkRadio(valueElement, pp.values[0]);
				}
				else
				{
					// check boxes
					Forms.checkCheckBoxes(valueElement, pp.values);
				}
			}
			else if (pp.multiplicity == 1)
			{
				Main.hide('valuecontainer');
				if (pp.values.length > 0)
				{
					if (valueElement.length) // ie. radio buttons for boolean parameter
					{
						Forms.checkRadio(valueElement, pp.values[0]);
					}
					else
					{
						valueElement.value = pp.values[0];
					}

				}
			}
			else
			{
				var values = frm.values;
				values.length = 0;
				for (var i = 0; i < pp.values.length; i++) // >
				{
					var value = Main.cutString(pp.values[i].replace(/\n/g, ' '), 40);
					values[values.length] = new Option(value);
				}
				var mult = document.getElementById('multiplicity');
				mult.innerHTML = pp.multiplicity == 0 ? '' : '(Max '+pp.multiplicity+' values)';
				Main.show('valuecontainer');
			}
		}

		var selectedParameter = null;
		var selectedParameterId = null;
		function getSelectedParameter()
		{
			return selectedParameter;
		}
		
		function setSelectedParameter(parameter, parameterId)
		{
			if (selectedParameter != null)
			{
				Main.removeClass(document.getElementById('prompt_'+selectedParameter.name), 'selected');
			}
			selectedParameter = parameter;
			selectedParameterId = parameterId;
			if (selectedParameter != null)
			{
				Main.addClass(document.getElementById('prompt_'+selectedParameter.name), 'selected');
			}
		}

		function updateSelectedStyle()
		{
			var pp = getSelectedParameter();
			var icon = document.getElementById('icon_'+pp.name);
			var gif = getRoot()+'images/';
			if (pp.values.length == 0)
			{
				gif += pp.required ? 'required_novalues.gif' : 'notrequired_novalues.gif';
			}
			else
			{
				gif += pp.required ? 'required_values.gif' : 'notrequired_values.gif';
			}
			icon.src = gif;
		}

		function setCurrentValue(value)
		{
			var pp = getSelectedParameter();
			if (value == null || value == '')
			{
				pp.removeValue(0);
			}
			else
			{
				pp.updateValue(0, value);
			}
			updateSelectedStyle();
		}

		function setEnumValues(name)
		{
			var pp = getSelectedParameter();
			if (!pp) return;
		
			var frm = document.forms['annotations'];
			var valueElement = frm[name];
			var values = new Array();
			for (var i = 0; i < valueElement.length; i++) // >
			{
				if (valueElement[i].checked || valueElement[i].selected) 
				{
					values[values.length] = valueElement[i].value;
				}
			}
			pp.setValues(values);
			updateSelectedStyle();
		}

		var lastValueIndex = -1;
		function valuesOnClick()
		{
			var frm = document.forms['annotations'];
			var pp = getSelectedParameter();
			lastValueIndex = frm.values.selectedIndex;
			if (lastValueIndex >= 0)
			{
				frm['value_'+pp.name].value = pp.values[lastValueIndex];
			}
		}
		
		function valueOnBlur(value)
		{
			var pp = getSelectedParameter();
			if (!pp) return;
			var frm = document.forms['annotations'];
			var unitList = frm['unit:'+pp.name];
			if (unitList) pp.setUnit(unitList[unitList.selectedIndex].value);
			if (pp.multiplicity == 1) 
			{
				setCurrentValue(value);
			}
			else
			{
				if (lastValueIndex < 0) return; // >
				if (value == '' || value == null)
				{
					pp.removeValue(lastValueIndex);
					frm.values[lastValueIndex] = null;
				}
				else
				{
					pp.updateValue(lastValueIndex, value);
					frm.values[lastValueIndex].text = value;
				}
			}
		}

		function addOnClick()
		{
			var pp = getSelectedParameter();
			if (!pp) return; 
			var frm = document.forms['annotations'];
			var valueElement = frm['value_'+pp.name];
			if (frm.values.selectedIndex < 0 && valueElement.value != '') // >
			{
				if (pp.addValue(valueElement.value))
				{
					lastValueIndex = frm.values.length;
					frm.values[lastValueIndex] = new Option(valueElement.value, '', false, false);
					valueElement.value = '';
					lastValueIndex = -1;
				}
			}
			else
			{
				if (pp.addValue(''))
				{
					lastValueIndex = frm.values.length;
					frm.values[lastValueIndex] = new Option('<new>', '', false, true);
					valueElement.value = '';
				}
			}
			valueElement.focus();
			updateSelectedStyle();
		}
		function removeOnClick()
		{
			var pp = getSelectedParameter();
			if (!pp) return;
			
			var frm = document.forms['annotations'];
			var values = frm.values;
			for (var i = 0; i < values.length; i++) // >
			{
				if (values[i].selected)
				{
					pp.removeValue(i);
					values[i] = null;
					i--;
				}
			}
			updateSelectedStyle();
		}

		function setDateCallback(frmName, inputName, theDate)
		{
			var frm = document.forms[frmName];
			frm[inputName].value = theDate;
			valueOnBlur(theDate);
		}

		function unitOnChange(unitList)
		{
			var pp = getSelectedParameter();
			if (!pp) return;
			pp.setUnit(unitList[unitList.selectedIndex].value);
		}
		
		function hideErrorList()
		{
			Main.hide('errorlist');
			Main.show('showerrorlist');
		}
		function showErrorList()
		{
			Main.show('errorlist');
			Main.hide('showerrorlist');
		}
	
		function saveAnnotations()
		{
			var frm = document.forms['modified'];
			Annotations.addModifiedAnnotationsToForm(window, frm);
			frm.submit();
		}
	</script>
	</base:head>
	
	<base:body onload="init()">
		<%
		if (standalone)
		{
			%>
			<h1><%=title%> <base:help helpid="annotations.edit" /></h1>
			<div class="content">
			<%
		}
		%>
	
		<form name="annotations">
		
		<div class="absolutefull">
			<div class="absolutefull filled rightborder" style="width: 18em;">
				<div class="absolutefull" style="height: 2em;">
					<table style="margin: auto; height: 100%;"><tr><td>
					<select name="categories" onchange="categoryOnChange()" style="width: 17em;">
					<option value="-1">- all -
					<%
					if (protocol != null)
					{
						%>
						<option value="-2">- protocol parameters -
						<%
					}
					%>
					<option value="0">- uncategorized -
					<%
					for (AnnotationTypeCategory category : allCategories)
					{
						boolean selected = category.getName().equals(selectedCategoryName);
						%>
						<option value="<%=category.getId()%>"
							title="<%=HTML.encodeTags(category.getDescription())%>"
							<%=selected ? "selected" : "" %>
						><%=HTML.encodeTags(category.getName())%>
						<%
					}
					%>
					</select>
					</td></tr></table>
				</div>
				
				<div class="absolutefull parameterlist topborder" 
					style="top: 2em; bottom: 3em;">
					<%
					if (annotationTypes.size() == 0)
					{
						%>
						<div class="messagecontainer error">
							There are no annotation types defined for this kind of item.
						</div>
						<%
					}
					%>
					<%=sb.toString()%>
				</div>
			
				<div class="absolutefull topborder" style="top: auto; bottom: 0px; height: 3em;">
					<table style="height: 100%; margin:auto;"><tr><td>
					<base:icon image="hasvalues.gif" /> = has value(s)<br>
					<base:icon image="parameter.png" /> = protocol parameter
					</td></tr></table>
				</div>
			</div>
			
			<div class="absolutefull input100" style="left: 18em; padding: 8px;">
				<%
				if (message != null)
				{
					%>
					<div class="messagecontainer help" style="margin-top: 0.2em;"><%=message%></div>
					<%
				}
				if (!writePermission)
				{
					%>
					<div class="messagecontainer error" >You do not have permission to change this information</div>
					<%
				}
				%>
				<div id="valuecontainer" style="display: none;">
					<b>Values</b> <span id="multiplicity"></span><br>
					<select name="values" size="5" style="width: 20em;"
						onchange="valuesOnClick()" multiple>
					</select>
				
					<table cellspacing="2" border="0" cellpadding="0" cellspacing="0" align="center">
					<tr>
						<td width="50%"><base:button onclick="addOnClick()" title="Add" tooltip="Add a new value" /></td>
						<td width="50%"><base:button onclick="removeOnClick()" title="Remove" tooltip="Remove the selected values"/></td>
					</tr>
					</table>
				<br>
				</div>
				<%
				for (AnnotationType at : annotationTypes)
				{
					Annotation a = as != null && as.hasAnnotation(at) ? as.getAnnotation(at) : null;
					int multiplicity = at.getMultiplicity();
					String inputName = "value_"+at.getId();
					Type valueType = at.getValueType();
					int width = at.getWidth() <= 0 ? 40 : at.getWidth();
					if (width > 80) width = 80;
					int height = at.getHeight() <= 0 ? 6 : at.getHeight();
					if (height > 20) height = 20;
					String select = null;
					if (multiplicity == 0)
					{
						select = "Select one or more";
					}
					else if (multiplicity == 1)
					{
						select = "Select one";
					}
					else
					{
						select = "Select 1 -- "+multiplicity;
					}
					
					%>
					<div id="<%=inputName%>_div" style="display: none;">
					
					<%
					if (at.isEnumeration())
					{
						List<?> values = at.getValues();
						Formatter f = FormatterFactory.getTypeFormatter(sc, at.getValueType());
						String unitSymbol = "";
						if (at.supportUnits()) unitSymbol = "&nbsp;" + at.getDefaultUnit().getDisplaySymbol();
						%>
						<b><%=HTML.encodeTags(at.getName())%></b> (<%=select%>)<br>
						<%
						if (at.getDisplayAsList())
						{
							if (multiplicity == 1)
							{
								%>
								<select name="<%=inputName%>"
									onchange="setCurrentValue(this[this.selectedIndex].value)">
								<option value="" style="font-style: italic;">- not specified -
								<%
							}
							else
							{
								%>
								<select name="<%=inputName%>" multiple size="10"
									onchange="setEnumValues('<%=inputName%>')">
								<%
							}
							for (Object value : values)
							{
								String encoded = f.format(value);
								%>
								<option value="<%=encoded%>"><%=encoded%><%=unitSymbol%>
								<%
							}
							%>
							</select>
							<%
						}
						else
						{
							String checkType = multiplicity == 1 ? "radio" : "checkbox";
							String onclick = multiplicity == 1 ? "setCurrentValue(this.value)" : "setEnumValues('"+inputName+"')";
							int i = 0;
							if (multiplicity == 1)
							{
								%>
								<input name="<%=inputName%>" type="<%=checkType%>" 
									checked value="" onclick="setCurrentValue(null)"><a
									href="javascript:document.forms['annotations'].<%=inputName%>[<%=i%>].click()"><i>- not specified -</i></a><br>
								<%
								i++;
							}
							for (Object value : values)
							{
								String encoded = f.format(value);
								%>
								<input name="<%=inputName%>" type="<%=checkType%>"
									value="<%=encoded%>" onclick="<%=onclick%>"><a 
									href="javascript:document.forms['annotations'].<%=inputName%>[<%=i%>].click()"><%=encoded%><%=unitSymbol%></a><br>
								<%
								i++;
							}
						}
					}
					else if (valueType == Type.INT || valueType == Type.LONG)
					{
						Long minValue = at.getMinValueLong();
						Long maxValue = at.getMaxValueLong();
						String minMax = "";
						if (minValue != null && maxValue != null)
						{
							minMax = ": " + minValue + " -- " +maxValue;
						}
						else if (minValue != null)
						{
							minMax = " >= "+minValue;
						}
						else if (maxValue != null)
						{
							minMax = " <= "+maxValue;
						}
						%>
						<b><%=HTML.encodeTags(at.getName())%></b>
						(<%=valueType == Type.INT ? "Integer" : "Long"%><%=minMax%>)<br>
						<input <%=clazz%> type="text" name="<%=inputName%>" value="" style="width: 12em;"
							maxlength="20" onkeypress="return Numbers.integerOnly(event)"
							onblur="valueOnBlur(this.value)">
						<%
					}
					else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
					{
						Double minValue = at.getMinValueDouble();
						Double maxValue = at.getMaxValueDouble();
						String minMax = "";
						if (minValue != null && maxValue != null)
						{
							minMax = ": " + minValue + " -- " +maxValue;
						}
						else if (minValue != null)
						{
							minMax = " >= "+minValue;
						}
						else if (maxValue != null)
						{
							minMax = " <= "+maxValue;
						}
						%>
						<b><%=HTML.encodeTags(at.getName())%></b>
						(<%=valueType == Type.FLOAT ? "Float" : "Double"%><%=minMax%>)<br>
						<input <%=clazz%> type="text" name="<%=inputName%>" value="" style="width: 12em;"
							maxlength="20" onkeypress="return Numbers.numberOnly(event)"
							onblur="valueOnBlur(this.value)">
						<%
					}
					else if (valueType == Type.STRING)
					{
						Integer maxLength = at.getMaxLength();
						if (maxLength == null) maxLength = 255;
						%>
						<b><%=HTML.encodeTags(at.getName())%></b> (String)<br>
						<input <%=clazz%> type="text" name="<%=inputName%>" value=""
							maxlength="<%=maxLength%>"
							onblur="valueOnBlur(this.value)">
						<%
					}
					else if (valueType == Type.TEXT)
					{
						%>
						<b><%=HTML.encodeTags(at.getName())%></b> (Text)<br>
						<table style="width: 100%;">
						<tr>
							<td>
							<textarea <%=clazz%> name="<%=inputName%>" rows="<%=height%>" 
									onblur="valueOnBlur(this.value)"></textarea>
							</td>
							<td style="width: 20px;">
								<base:icon image="zoom.png" 
									onclick="<%="Main.zoom('" + HTML.javaScriptEncode(at.getName()) +"', 'annotations', '" + inputName + "')"%>"
									tooltip="Edit in larger window"
								/>
							</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.BOOLEAN)
					{
						%>
						<b><%=HTML.encodeTags(at.getName())%></b><br>
						<input type="radio" name="<%=inputName%>" id="<%=inputName%>.null" value="" checked
							onclick="setCurrentValue(null)"><label for="<%=inputName%>.null"><i>- not specified -</i></label><br>
						<input type="radio" name="<%=inputName%>" id="<%=inputName%>.true" value="true" 
							onclick="setCurrentValue('true')"><label for="<%=inputName%>.true">true</label><br>
						<input type="radio" name="<%=inputName%>" id="<%=inputName%>.false" value="false" 
							onclick="setCurrentValue('false')"><label for="<%=inputName%>.false">false</label>
						<%
					}
					else if (valueType == Type.DATE)
					{
						%>
						<table>
						<tr>
						<td>
							<b><%=HTML.encodeTags(at.getName())%></b> (Date)<br>
							<input <%=clazz%> type="text" name="<%=inputName%>" value="" style="width: 15em;"
								maxlength="20" title="Enter date in format: <%=htmlDateFormat%>"
								onblur="valueOnBlur(this.value)">
						</td>
						<td>
								<br>
								<base:button 
									onclick="<%="Dates.selectDate('Value', 'annotations', '"+inputName+"', 'setDateCallback', '"+jsDateFormat+"')"%>" 
									image="calendar.png"
									title="Calendar&hellip;" 
									tooltip="Select a date from a calendar" 
								/>
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.TIMESTAMP)
					{
						%>
						<table>
						<tr>
						<td>
							<b><%=HTML.encodeTags(at.getName())%></b> (Timestamp)<br>
							<input <%=clazz%> type="text" name="<%=inputName%>" value="" style="width: 20em;"
								maxlength="30" title="Enter date + time in format: <%=htmlDateTimeFormat%>"
								onblur="valueOnBlur(this.value)">
						</td>
						<td>
								<br>
								<base:button 
									onclick="<%="Dates.selectDateTime('Value', 'annotations', '"+inputName+"', 'setDateCallback', '"+jsDateTimeFormat+"')"%>" 
									image="calendar.png"
									title="Calendar&hellip;" 
									tooltip="Select date and time from a calendar" 
								/>
						</td>
						</tr>
						</table>
						<%
					}
					if (at.supportUnits() && !at.isEnumeration())
					{
						ItemQuery<Unit> unitQuery = at.getUsableUnits();
						if (unitQuery.count(dc) == 0)
						{
							unitQuery = at.getQuantity().getUnits();
						}
						else
						{
							unitQuery.reset();
						}
						unitQuery.order(Orders.desc(Hql.property("referenceFactor")));
						unitQuery.order(Orders.asc(Hql.property("displaySymbol")));
						List<Unit> units = unitQuery.list(dc);
						Unit current = a != null ? a.getUnit() : null;
						if (current == null) current = at.getDefaultUnit();
						%>
						
						<select name="unit:<%=at.getId()%>" onchange="unitOnChange(this)">
						<%
						boolean hasSelected = false;
						for (Unit unit : units)
						{
							String selected = "";
							if (unit.equals(current))
							{
								selected = " selected";
								hasSelected = true;
							}
							%>
							<option value="<%=unit.getId()%>" <%=selected%> 
								title="<%=HTML.encodeTags(unit.getName() + " - " + unit.getDescription()) %>"
								><%=HTML.encodeTags(unit.getDisplaySymbol())%>
							<%
						}
						if (!hasSelected && current != null)
						{
							%>
							<option value="<%=current.getId()%>" selected 
								title="<%=HTML.encodeTags(current.getName() + " - " + current.getDescription()) %>"
								><%=HTML.encodeTags(current.getDisplaySymbol())%>
							<%
						}
						%>
						</select>
						<%
					}
					%>
					
					<%
					if (at.getDescription() != null)
					{
						%>
						<div class="messagecontainer help" style="margin-left: 0px; margin-right: 0px;">
						<%=HTML.niceFormat(at.getDescription())%>
						</div>
						<%
					}
					%>
					</div>
					<%
				}
				%>
			</div>
		</div>
		</form>
		<%
		if (standalone)
		{
			%>
			</div>
			<base:buttongroup subclass="dialogbuttons topborder">
				<base:button onclick="saveAnnotations()" title="Save" visible="<%=writePermission%>" />
				<base:button onclick="window.close()" title="Cancel"  visible="<%=writePermission%>" />
				<base:button onclick="window.close()" title="Close" visible="<%=!writePermission%>" />
			</base:buttongroup>
			<form name="modified" method="post" action="index.jsp?ID=<%=ID%>">
				<input type="hidden" name="cmd" value="SaveAnnotations">
				<input type="hidden" name="item_type" value="<%=itemType.name()%>">
				<input type="hidden" name="item_id" value="<%=itemId%>">
			</form>
			<%
		}
		%>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
