<%-- $Id: not_logged_in.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is used to catch NotLoggedInExceptions which are
	directed here via the exception.jsp page. NotLoggedInExceptions
	happen when a user tries to access a protected page without beeing
	logged in. Typically the exception is thrown from the method that
	retrieves the BaseControl object:

	BASE.getExistingBaseControl(pageContext);

	This page will display a new login form allowing the user
	to login again and continue with what he/she was doing.

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	isErrorPage="true"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld"
%>
<%
final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final String root = request.getContextPath()+"/";
final String redirect = Values.getString((String)request.getAttribute("redirect"));
%>
<base:page type="default" menu="exception" title="">
<base:head scripts="exception.js" styles="login.css">
	<script language="JavaScript">
	// hide menubar and resize if it is a popup window
	function init()
	{
		Exception.fixWindow(true);
		setFocus();
	}
	// Set the focus on either the login or password field.
	function setFocus()
	{
		var frm = document.forms['login'];
		var topWindow = getTopWindow(false);
		if (topWindow.lastLogin) 
		{
			frm.login.value = topWindow.lastLogin;
			Main.show('timeout');
		}
		if (frm.login.value == '')
		{
			frm.login.focus();
			frm.login.select();
		}
		else
		{
			frm.password.focus();
			frm.password.select();
		}
	}
	
	function mainPage()
	{
		var topWindow = getTopWindow(true);
		topWindow.main.document.location = '<%=root%>main.jsp';
	}
	function getTopWindow(closePopups)
	{
		var topWindow = window.top;
		if (topWindow.opener != null)
		{
			var i = 1;
			while ((topWindow.opener != null) && (i <10))  // >
			{
				i = i+1
				var popupWindow = topWindow;
				topWindow = topWindow.opener.top;
			}
			if (closePopups) popupWindow.close();
		}
		return topWindow;
	}
	function doLogin()
	{
		var frm = document.forms['login'];
		Main.openPopup('', 'Login', 300, 200);
		frm.submit();
	}
	</script>
</base:head>
<base:body onload="init()">

		<form action="<%=root%>login.jsp?again=1" method="post" name="login" target="Login" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="redirect" value="<%=redirect%>">

		<table style="margin: auto; width: 600px; margin-top:5em; ">
		<tr>
		<td>

			<table style="width: 100%;">
			<tr>
				<td style="background-color: #000000; border-radius: 4px 0px 0px 4px;"><img src="<%=root%>images/baselogo.png" alt="BASE logo"></td>
				<td>
					<div id="loginform">
					<table>
						<tr>
							<th>Login</th>
							<td><input class="text" type="text" name="login"  
								maxlength="100"	style="width: 12em;" 
								tabindex="0"
								>
							</td>
							<td></td>
						</tr>
						<tr>
							<th>Password</th>
							<td>
								<input class="text" type="password" name="password" maxlength="80"
									onkeypress="return Forms.submitOnEnter(event, doLogin)"
									style="width: 12em;" 
									tabindex="0"
									>
							</td>
							<td>
								<base:buttongroup>
									<base:button image="login.png" onclick="doLogin();" title="Login" />
									<base:button onclick="mainPage();" title="Cancel" />
								</base:buttongroup>
							</td>
						</tr>
						<tr>
							<th></th>
							<td colspan="2">
							<%
							String forgotPassword = sc.getClientDefaultSetting("server.forgotten.password");
							String getAccount = sc.getClientDefaultSetting("server.get.account");
							if (forgotPassword != null)
							{
								%>
								<base:icon image="bullet.png" />
								<a href="javascript:Main.openPopup('info/forgot_password.jsp?ID=<%=ID%>', 'ForgotPassword', 450, 300)" title="Click here if you have forgotten your password">Forgot your password?</a>
								<%
							}
							if (getAccount != null)
							{
								%>
								<base:icon image="bullet.png" />
								<a href="javascript:Main.openPopup('info/get_account.jsp?ID=<%=ID%>', 'GetAccount', 450, 300)" title="Click here if you want to get an account on this server">Get an account!</a>
								<%
							}
							%>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>

				<div class="messagecontainer error" id="timeout" style="display: none;">
					<b>Not logged in</b><br>
					You have been automatically logged out due to inactivity or because the 
					server has been restarted.
					You may log in again and continue your work but unsaved changes 
					may have been lost.
				</div>


		</td>
		</tr>
		</table>

	</form>
</base:body>
</base:page>
