<%-- $Id: impersonate.jsp 5977 2012-02-20 13:26:26Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final String login = Values.getString(request.getParameter("login"), "");
final String error = Values.getString(request.getParameter("error"), null);
final String root = request.getContextPath()+"/";

final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
ItemResultList<News> news = null;
try
{
	User currentUser = null;
	int userId = Values.getInt(request.getParameter("user_id"));
	if (userId != 0) currentUser = User.getById(dc, userId);
	%>
	<base:page type="popup" title="Impersonate user">
	<base:head scripts="md5.js" styles="login.css">
		<script language="JavaScript" type="text/javascript">
		function doLogin()
		{
			var frm = document.forms['login'];
			if (frm.remainOnPage.checked) 
			{
				frm.redirect.value = window.opener.location.href;
			}
			else
			{
				frm.redirect.value = '<%=root%>my_base/index.jsp?ID=<%=ID%>';
			}
			frm.submit();
		}
		function selectUserOnClick()
		{
			var frm = document.forms['login'];
			var url = 'admin/users/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setUserCallback';
			if (frm.user_id.length > 0)
			{
				var id = Math.abs(parseInt(frm.user_id[0].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectUser', 1050, 700);
		}
		function setUserCallback(id, name)
		{
			var frm = document.forms['login'];
			var list = frm.user_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		</script>
	</base:head>
	
	<base:body onload="init();">
		<h1>Impersonate user <base:help helpid="impersonateuser" /></h1>
		<form name="login" action="login.jsp" method="post" onsubmit="doLogin();">
		<input type="hidden" name="cmd" value="Impersonate">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="again" value="1">
		<input type="hidden" name="redirect" value="">
	
		<div class="content">
			<table class="fullform input100 bottomborder">
			<%
			if (error != null) 
			{
				%>
				<tr>
					<td colspan="3">
					<div class="messagecontainer error"><%=error%></div>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>User</th>
				<td colspan="2">
					<base:select 
						id="user_id"
						clazz="selectionlist"
						required="true"
						current="<%=currentUser%>"
						recent="<%=null%>"
						newitem="true"
						onselect="selectUserOnClick()"
					/>
				</td>
				
			</tr>
			<tr>
				<th><label for="remainOnPage">Remain on page</label></th>
				<td>
					<input type="checkbox" name="remainOnPage" id="remainOnPage" checked value="1">
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Comment</th>
				<td>
					<textarea class="text" rows="6" name="comment"></textarea>
				</td>
				<td>
					<a href="javascript:Main.zoom('Comment', 'login', 'comment')"
						title="Edit in larger window"><base:icon image="zoom.png" /></a>
				</td>
			</tr>
			</table>
		</div>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button image="login.png" onclick="doLogin();" title="Impersonate" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

