/* $Id$
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	JavaScript functions for sending Ajax request. Create a
	request with Main.getAjaxRequest() or Ajax.getXmlHttpRequest().

	@author Nicklas
	@version 2.0
*/

var DragDrop = new DragDropClass();

function DragDropClass()
{
	
	this.isDragging = false;
	this.startX = 0;
	this.startY = 0;
	this.callback = null;
	this.horizontal = false;
	this.vertical = false;
	
	/*
		Start dragging. The 'event' parameter is used to get
		the mouse position. The callback function is called
		when the mouse is moved to handle the drag visually.
	*/
	this.beginDrag = function(event, horizontal, vertical, callback)
	{
		this.startX = event.screenX;
		this.startY = event.screenY;
		this.callback = callback;
		this.horizontal = horizontal;
		this.vertical = vertical;
		this.isDragging = true;
	}
	
	/*
		Recieve mouse move events. Calculate the delta X and Y since the
		last position and call the callback function.
	*/
	this.drag = function(event)
	{
		if (!this.isDragging) return;
		var deltaX = event.screenX - this.startX;
		var deltaY = -(event.screenY - this.startY);
		
		if ((this.horizontal && Math.abs(deltaX) > 0) || (this.vertical && Math.abs(deltaY) > 0)) 
		{
			this.callback(deltaX, deltaY);
			this.startX = event.screenX;
			this.startY = event.screenY;
		}
	}
	
	/*
		End dragging.
	*/
	this.endDrag = function(event)
	{
		if (!this.isDragging) return;
		this.isDragging = false;
	}
	
}

