<%-- $Id: merge_plates_2.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.CREATE, itemType);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	final int plateMappingId = Values.getInt(request.getParameter("platemapping_id"));
	final int plateTypeId = Values.getInt(request.getParameter("platetype_id"));
	final PlateMapping plateMapping = PlateMapping.getById(dc, plateMappingId);
	final PlateType plateType = PlateType.getById(dc, plateTypeId);
	PlateGeometry sourceGeometry = plateMapping.getSourceGeometry();
	
	if (!plateMapping.getDestinationGeometry().equals(plateType.getPlateGeometry()))
	{
		throw new WebException("popup", "Incomatible plate type and plate mapping", 
			"The selected plate type has a different geometry than the mapping.");
	}
	
	String title = "Merge plates -- step 2 of 2 -- Select plates";
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="linkitems.js">
		<script language="JavaScript">
		// Validate the entered information
		function validate()
		{
			var frm = document.forms['merge'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.plates.length != <%=plateMapping.getSourceCount()%>)
			{
				alert("You must select exactly <%=plateMapping.getSourceCount()%> plates");
				return false;
			}
			return true;
		}

		// Submit the form
		function mergePlates()
		{
			var frm = document.forms['merge'];
			if (validate())
			{
				frm.mergePlates.value = Link.getActionIds(1, 'P').join(',');
				frm.submit();
			}
		}
		
		function addPlatesOnClick()
		{
			var ids = Link.getListIds(document.forms['merge'].plates, 'P');
			var excludes = ids.join(',');
			var url = '../plates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addPlateCallback';
			url += "&exclude="+excludes;
			url += '&resetTemporary=1&tmpfilter:INT:plateType.plateGeometry=<%=sourceGeometry.getId()%>';
			Main.openPopup(url, 'AddPlates', 1050, 700);
		}

		function addPlateCallback(plateId, name)
		{
			var item = Link.getItem('P', plateId);
			if (!item) item = new Item('P', plateId, name);
			Link.addItem(document.forms['merge'].plates, item);
		}
		
		function removePlatesOnClick()
		{
			Link.removeSelected(document.forms['merge'].plates);
		}
		</script>
	</base:head>
	<base:body>
		<h1><%=title%> <base:help helpid="plates.merge.2" /></h1>

		<form action="index.jsp?ID=<%=ID%>" method="post" name="merge" onsubmit="return false;">
		<input type="hidden" name="cmd" value="MergePlates">
		<input type="hidden" name="platemapping_id" value="<%=plateMappingId%>">
		<input type="hidden" name="platetype_id" value="<%=plateTypeId%>">

		<div class="content bottomborder">
			<table class="fullform input100 smaller">
			<tr>
				<th>Plate mapping</th>
				<td>
					<table><tr>
						<td><%=HTML.encodeTags(plateMapping.getName())%></td>
					<%
					if (plateMapping.getImage() !=  null)
					{
						%>
						<td><img src="../../images/platemappings/<%=plateMapping.getImage()%>"></td>
						<%
					}
					%>
					</tr></table>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" value="<%=HTML.encodeTags(request.getParameter("name"))%>" 
					maxlength="<%=Plate.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<th>Plate type</th>
				<td><%=HTML.encodeTags(plateType.getName())%></td>
			</tr>
			<tr class="big">
				<th>Plates</th>
				<td>
				<table>
				<tr>
					<td style="padding: 5px;">
						<base:buttongroup vertical="true">
							<base:button
								onclick="Forms.moveListOptions(document.forms['merge'].plates, false)" 
								image="move_up.png" 
								tooltip="Move up" 
								subclass="square"
							/>
							<base:button 
								onclick="Forms.moveListOptions(document.forms['merge'].plates, true)" 
								image="move_down.png" 
								tooltip="Move down" 
								subclass="square"
							/>
						</base:buttongroup>
					</td>
					<td>
						<select name="plates" size="<%=plateMapping.getSourceCount()%>" multiple 
							style="width: 15em;" class="required">
						</select>
						<input type="hidden" name="mergePlates">
					</td>
					<td>
						<base:buttongroup vertical="true">
							<base:button 
								subclass="leftaligned"
								style="width: 14em;"
								onclick="addPlatesOnClick()" 
								title="Add&nbsp;plates&hellip;" 
								tooltip="Add plates to be used"
							/>
							<base:button 
								subclass="leftaligned"
								style="width: 14em;"
								onclick="removePlatesOnClick()" 
								title="Remove" 
								tooltip="Remove the selected plates"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</div>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="mergePlates()" title="Merge" image="gonext.png"/>
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
