<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.VirtualTable"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="java.util.Arrays"
	import="java.util.Date"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.EXPERIMENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Clone reporters";
	Experiment experiment = Experiment.getById(dc, itemId);
	experiment.checkPermission(Permission.WRITE);
	VirtualDb virtualDb = experiment.getVirtualDb();
	boolean canCloneFromRaw = experiment.getRawDataType().isStoredInDb();
	boolean canCloneFromVirtual = virtualDb.hasTable(VirtualTable.POSITION);
	
	if (!canCloneFromRaw && !canCloneFromVirtual)
	{
		throw new BaseException("Can't clone reporters for experiment since it has no raw data or analyzed data");
	}
	
	List<ReporterCloneTemplate> recentTemplates = (List<ReporterCloneTemplate>)cc.getRecent(dc, Item.REPORTERCLONETEMPLATE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Experiment" tab
		function validateExperiment()
		{
			var frm = document.forms['clone'];
			
			if (frm.reporterclonetemplate_id.selectedIndex < 0)
			{
				alert('A template must be selected');
				frm.reporterclonetemplate_id.focus();
				return false;
			}

			return true;
		}
		
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['clone'];
			if (validateExperiment())
			{
				frm.submit();
			}
		}
		
		function selectTemplateOnClick()
		{
			var frm = document.forms['clone'];
			var url = '../../admin/reporterclonetemplates/index.jsp?ID=<%=ID%>&mode=selectone&callback=setTemplateCallback';
			if (frm.reporterclonetemplate_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.reporterclonetemplate_id[0].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectReporterCloneTemplate', 1050, 700);
		}
		function setTemplateCallback(id, name)
		{
			var frm = document.forms['clone'];
			var list = frm.reporterclonetemplate_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		function init()
		{
			var frm = document.forms['clone'];
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help helpid="experiment.clonereporters" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="clone" onsubmit="return false;">
		<input type="hidden" name="cmd" value="CloneReporters">
		<input type="hidden" name="item_id" value="<%=itemId %>">

		<div class="content bottomborder">
			<table class="fullform input100">
			<tr>
				<th>Clone template</th>
				<td>
					<base:select 
						id="reporterclonetemplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=null%>"
						denied="<%=false%>"
						recent="<%=recentTemplates%>"
						newitem="<%=false%>"
						unselectedtext="- all properties -"
						onselect="selectTemplateOnClick()"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Clone source</th>
				<td>
					<select name="cloneSource">
					<%
					if (canCloneFromRaw && canCloneFromVirtual)
					{
						%>
						<option value="AUTO">Auto
						<%
					}
					if (canCloneFromVirtual)
					{
						%>
						<option value="VIRTUAL">Analyzed data
						<%
					}
					if (canCloneFromRaw)
					{
						%>
						<option value="RAW">Raw data
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("description") : experiment.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'clone', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</div>
		</form>
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Next" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
