<%-- $Id: index.jsp 5897 2011-12-02 11:09:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.DynamicReporterQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.plugins.CloneReportersPlugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Collections"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("@externalId", "cln.externalId,upToDate");
	private static final Item itemType = Item.REPORTER;
%>
<%
final int experimentId = Values.getInt(request.getParameter("experiment_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String listPage = "list_reporters.jsp?ID="+ID+"&experiment_id="+experimentId;
final String subContext = "clonedreporters." + experimentId;
if (experimentId != 0) sc.getCurrentContext(Item.EXPERIMENT).setId(experimentId);

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, (PageContext)null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		dc = sc.newDbControl();
		final Experiment experiment = Experiment.getById(dc, experimentId);
		final DynamicReporterQuery query = Reporter.getDynamicQuery(experiment);
		dc.close();
		cc.setQuery(query);
		redirect = "../../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subContext+"&context_type=LIST&title=Export+bioassay+sets";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		dc = sc.newDbControl();
		final Experiment experiment = Experiment.getById(dc, experimentId);
		final DynamicReporterQuery query = Reporter.getDynamicQuery(experiment);
		dc.close();
		cc.setQuery(query);
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subContext+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("CreateReporterList".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		dc = sc.newDbControl();
		final Experiment experiment = Experiment.getById(dc, experimentId);
		final DynamicReporterQuery query = Reporter.getDynamicQuery(experiment);
		cc.configureQuery(dc, query, Collections.singletonList("@id"));
		dc.close();
		cc.setQuery(query);
		redirect = "../../../views/reporterlists/index.jsp?ID="+ID+
			"&cmd=NewItem&addReporters=1&formId=reporters&fromContext=" + itemType.name() + "&subContext=" + subContext +
			"&name=" + HTML.urlEncode(experiment.getName());
	}
	else if ("UpdateClonedReporters".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		
		dc = sc.newDbControl();
		Experiment exp = Experiment.getById(dc, experimentId);
		VirtualDb virtualDb = exp.getVirtualDb();
		if (!virtualDb.hasClonedReporters())
		{
			throw new WebException("popup", "This experiment has no cloned reporters", "");
		}
		ReporterCloneTemplate template = exp.getVirtualDb().getReporterCloneTemplate();
		
		PluginDefinition clonePlugin = PluginDefinition.getByClassName(dc, CloneReportersPlugin.class.getName());
		Job cloneJob = Job.getNew(dc, clonePlugin, null, exp);
		cloneJob.setName("Update cloned reporters using template '" + template.getName() + "'");

		cloneJob.setDescription(Values.getStringOrNull(request.getParameter("description")));
		cloneJob.setParameterValue("template", "Reporter clone template", null, 
			new ItemParameterType<ReporterCloneTemplate>(ReporterCloneTemplate.class, null), template);
		cloneJob.setParameterValue("cloneSource", "Clone source", null, new StringParameterType(), "VIRTUAL");
		dc.saveItem(cloneJob);
		dc.commit();
		
		redirect = "../../jobs/index.jsp?ID=" + ID + "&cmd=ViewItem&item_id="+cloneJob.getId();
		
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

